package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.HasGson;
import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.p4base.ResultMap;
import com.perforce.hws.core.p4base.ResultMapMethods;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.route.UsesJsonRequests;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;
import com.perforce.p4client.models.BranchCommand;
import spark.Request;
import spark.Response;
import spark.Route;

import java.util.List;

/**
 * POST /p4/:api/branches
 */
public class PerforceAddBranchRoute implements
        Route,
        P4Methods,
        HasGson,
        ResultMapMethods,
        ModelConversion,
        UsesJsonRequests,
        UsesServerHandles {

    @Override
    public Object handle(Request request, Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");

        BranchCommand branch = readModel(request, BranchCommand.class);

        return withServerHandle(server, sessionData, settings, serverHandle -> {
            List<ResultMap> results = execInput(serverHandle,
                    toRequestMap(branch),
                    "branch", "-i");

            return toCommandResponse(results);
        });
    }
}
