package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.HasGson;
import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.p4base.ResultMapMethods;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.route.UsesJsonRequests;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;
import com.perforce.p4client.models.ClientCommand;

/**
 * POST /p4/:api/clients
 */
public class PerforceAddClientRoute implements
        spark.Route,
        P4Methods,
        HasGson,
        ResultMapMethods,
        ModelConversion,
        UsesJsonRequests,
        UsesServerHandles {

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");

        ClientCommand clientCommand = readModel(request, ClientCommand.class);

        java.util.Map<String, Object> inputMap = toRequestMap(clientCommand);

        return withServerHandle(server, sessionData, settings,
                serverHandle -> toCommandResponse(execInput(serverHandle, inputMap, "client", "-i")));
    }
}
