package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.p4base.ResultMap;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;

/**
 * POST /jobs/{job}/fixes/{change}
 */
public class PerforceAddJobFixRoute implements
        spark.Route,
        P4Methods,
        ModelConversion,
        UsesServerHandles {

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");

        String job = request.params("job");
        String change = request.params("change");
        String status = request.queryParams("status");

        return withServerHandle(server, sessionData, settings, serverHandle -> {
            java.util.List<ResultMap> resultMaps = null;

            if (status != null) {
                resultMaps = exec(serverHandle, "fix", "-c", change, "-s", status, job);
            } else {
                resultMaps = exec(serverHandle, "fix", "-c", change, job);
            }

            return toCommandResponse(resultMaps);
        });
    }
}
