package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.HasGson;
import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.p4base.ResultMapMethods;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.route.UsesJsonRequests;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;
import com.perforce.p4client.models.UserCommand;

/**
 * POST /p4/:api/users
 */
public class PerforceAddUserRoute implements
        spark.Route,
        P4Methods,
        ModelConversion,
        HasGson,
        ResultMapMethods,
        UsesJsonRequests,
        UsesServerHandles {

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");

        UserCommand userCommand = readModel(request, UserCommand.class);

        java.util.Map<String, Object> requestMap = toRequestMap(userCommand);

        return withServerHandle(server, sessionData, settings,
                serverHandle -> toCommandResponse(execInput(serverHandle, requestMap, "user", "-f", "-i")));
    }
}

