package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;

/**
 * DELETE /p4/:api/jobs/:job
 */
public class PerforceDeleteJobRoute implements
        spark.Route,
        ModelConversion,
        P4Methods,
        UsesServerHandles {

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");
        String job = request.params("job");

        return withServerHandle(server, sessionData, settings,
                serverHandle -> toCommandResponse(exec(serverHandle, "job", "-d", job)));
    }
}
