package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.route.StreamRoute;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;

/**
 * DELETE /p4/:api/streams/:stream
 */
public class PerforceDeleteStreamRoute implements
        spark.Route,
        P4Methods,
        ModelConversion,
        StreamRoute,
        UsesServerHandles {

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");
        String stream = getStream(request);

        return withServerHandle(server, sessionData, settings,
                serverHandle -> toCommandResponse(exec(serverHandle, "stream", "-d", stream)));
    }
}

