package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.p4base.ResultMap;
import com.perforce.hws.core.p4base.ResultMapMethods;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.route.StreamRoute;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;

/**
 * GET /p4/:api/streams/*
 */
public class PerforceGetStreamRoute implements
        spark.Route,
        P4Methods,
        ResultMapMethods,
        ModelConversion,
        StreamRoute,
        UsesServerHandles {

    org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(PerforceGetStreamRoute.class);

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");
        String stream = getStream(request);

        return withServerHandle(server, sessionData, settings, serverHandle -> {
            java.util.List<ResultMap> results = exec(serverHandle, "stream", "-o", stream);
            ResultMap resultMap = firstResultOrFail(results);
            return toStreamCommand(resultMap, offsetSupplier(serverHandle));
        });
    }
}
