package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.p4base.ResultMap;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;

/**
 * GET /{server}/users
 */
public class PerforceListUsersRoute implements
        spark.Route,
        P4Methods,
        ModelConversion,
        UsesServerHandles {

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");

        String includeService = request.queryParams("includeService");
        String max = request.queryParams("max");

        java.util.List<String> args = new java.util.ArrayList<>();
        if (includeService != null && Boolean.valueOf(includeService)) {
            args.add("-a");
        }
        if (max != null) {
            args.add("-m");
            args.add(max);
        }

        return withServerHandle(server, sessionData, settings, serverHandle -> {
            java.util.List<ResultMap> resultMapList = exec(serverHandle, "users", args.toArray(new String[0]));

            java.util.function.Supplier<String> offsetSupplier = offsetSupplier(serverHandle);

            return resultMapList.stream().map(r -> toUsersCommand(r, offsetSupplier))
                    .collect(java.util.stream.Collectors.toList());
        });
    }
}
