package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.HasGson;
import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.p4base.ResultMap;
import com.perforce.hws.core.p4base.ResultMapMethods;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.route.HasArgList;
import com.perforce.hws.route.UsesCommandWhitelist;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;

import static spark.Spark.halt;

/**
 * POST /p4/:api/commands/:command
 */
public class PerforceRunCommandWithInputRoute implements
        spark.Route,
        HasArgList,
        HasGson,
        UsesCommandWhitelist,
        P4Methods,
        ResultMapMethods,
        ModelConversion,
        UsesServerHandles {

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");
        String command = request.params("command");

        java.util.List<String> argList = argList(request);

        String json = request.body();

        java.util.Map<String, Object> data =
                gson.fromJson(json, objectMapType);

        java.util.Map<String, Object> inputMap = divideArrayEntries(data);

        if (!isWhitelisted(settings, command, argList)) {
            halt(400);
        }

        return withServerHandle(server, sessionData, settings, serverHandle -> {
            java.util.List<ResultMap> resultMaps =
                    execInput(serverHandle, inputMap, command, argList.toArray(new String[0]));

            return toCommandResponse(resultMaps);
        });
    }
}
