package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.HasGson;
import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.p4base.ResultMap;
import com.perforce.hws.core.p4base.ResultMapMethods;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.route.UsesJsonRequests;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;
import com.perforce.p4client.models.ClientCommand;

/**
 * PATCH /{server}/clients/{client}
 */
public class PerforceUpdateClientRoute implements
        spark.Route,
		P4Methods,
		ResultMapMethods,
		HasGson,
		ModelConversion,
		UsesJsonRequests,
		UsesServerHandles {

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");
        String branch = request.params("client");

        return withServerHandle(server, sessionData, settings, serverHandle -> {
            ClientCommand clientCommand = readModel(request, ClientCommand.class);

            java.util.Map<String, Object> updates = toRequestMap(clientCommand);

            java.util.List<ResultMap> results = exec(serverHandle, "client", "-o", branch);
            java.util.Map<String, Object> current = collateArrayEntries(results.get(0));

            current.putAll(updates);

            java.util.Map<String, Object> toUpdate = divideArrayEntries(current);

            return toCommandResponse(execInput(serverHandle, toUpdate, "client", "-i"));
        });
    }
}
