package com.perforce.hws.plugin.perforce.routes;

import com.perforce.hws.core.p4base.HasGson;
import com.perforce.hws.core.p4base.P4Methods;
import com.perforce.hws.core.p4base.ResultMap;
import com.perforce.hws.core.p4base.ResultMapMethods;
import com.perforce.hws.core.p4base.ServerSpecMethods;
import com.perforce.hws.core.sessions.SessionData;
import com.perforce.hws.route.UsesJsonRequests;
import com.perforce.hws.utils.HWSSettings;
import com.perforce.hws.utils.ModelConversion;
import com.perforce.hws.utils.UsesServerHandles;
import com.perforce.p4client.models.ServerCommand;

/**
 * PATCH /p4/:api/servers/:server
 */
public class PerforceUpdateServerRoute implements
        spark.Route,
		P4Methods,
		ResultMapMethods,
		ServerSpecMethods,
		ModelConversion,
		HasGson,
		UsesJsonRequests,
		UsesServerHandles {

    @Override
    public Object handle(spark.Request request, spark.Response response) throws Exception {
        SessionData sessionData = request.attribute("sessionData");
        HWSSettings settings = request.attribute("settings");

        String server = request.params("server");
        String serverId = request.params("serverId");

        return withServerHandle(server, sessionData, settings, serverHandle -> {
            ServerCommand updateCommand = readModel(request, ServerCommand.class);
            java.util.Map<String, Object> updates = toRequestMap(updateCommand);

            java.util.List<ResultMap> results = exec(serverHandle, "server", "-o", serverId);
            ResultMap resultMap = firstResultOrFail(results);
            java.util.Map<String, Object> current = toRequestMap(toServerCommand(resultMap));

            current.putAll(updates);

            return toCommandResponse(saveServerSpec(serverHandle, current));
        });
    }
}
